/* parse.y & lex.l */

#if defined(__cplusplus)
extern "C" {
#endif

/* parse.y: */
int parse_file(const char *fileName);
int parse_cmdo(const char *cmd, const char *fname);/*KS added o so as not to conflict with parsecmd version*/
void parse_gstatrc(void);
#ifdef VARIO_H
int read_variogramo(VARIOGRAM *v, const char *source); /*KS added o so as not to conflict with parsecmd version*/
#endif

//#ifdef DATA_H			/*KS put this in parse.h*/
//int read_vector(D_VECTOR *d, char *fname);
//#endif




/* lex.l: */
int yylex(void);
/*void lex_error(void);*/
char *lex_error(void); /*KS replaced*/
void set_lex_source(/*const */char *source, const char *fname);

#define LX_IDENTIFIER   190 /* unquoted word */            /*KS added from OLDER version Gstat*/
#define LX_INT          191 /* integer */
#define LX_REAL         192 /* real */
#define LX_LB           40 //193 /* ( */
#define LX_RB           41 //194 /* ) */
#define LX_COMMA        44 /* , */
#define LX_EQ           61 /* = */
#define LX_PLUS         43 /* + */
#define LX_MINUS        45 /* - */
#define LX_COLON        58 //199 /* : */
#define LX_SEMICOLON    59 //200 /* ; */
#define LX_AMPERSAND    38 //201 /* & */
#define LX_WS           202 /* space, tab, newline or comment */
#define LX_STRING       39 //203 /* quoted string: "bla bla" or 'bla bla' */
#define LX_QMARK        204 /* ? */
#define LX_AT           64 // 205 /* @ */
#define LX_SYMBOL       206 /* anything else */


#if defined(__cplusplus)
}
#endif
